package mobicomp.mhcounter;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import mobicomp.interfaces.MHMessage;
import mobicomp.interfaces.MHSocket;
import mobicomp.net.MHMessageImpl;
import mobicomp.net.MHSocketImpl;
import mobicomp.net.MessageListener;

public class MHCounter implements MessageListener {

	// n knoten, 1 fngt an. zhlen von 1 bis k.
	// n+1 nicht erreichbar -> wieder an 1 weitergeben.
	
	private int id;
	private int target;
	private boolean running = true;
	
	private MHSocket socket;

	public MHCounter( int id, int target) throws IOException {
		this.id = id;
		this.target = target;
		
		socket = new MHSocketImpl( id, this);
		
		if (id == 1) {
			// start counting
			MHMessage msg = new MHMessageImpl();
			msg.setType( MHMessage.TYPE_SRMSG);
			msg.setSender( 1);
			msg.setReceiver( 2);
			msg.setData( intToBytes( 0));
			
			socket.send( msg);
		}
		
		while ( running ) {
			try {
				Thread.sleep( 1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		// TODO: socket.close()
	}
	
	private byte[] intToBytes( int i) {
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		DataOutputStream out = new DataOutputStream( bos);
		try {
			out.writeInt( i);
			out.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return bos.toByteArray();
	}
	
	private int bytesToInt( byte[] bytes) {
		ByteArrayInputStream bis = new ByteArrayInputStream( bytes);
		DataInputStream in = new DataInputStream( bis);
		int i=1;
		try {
			i = in.readInt();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return i;
	}
	
	private void stop() {
		running = false;
		System.out.println( id + ": shutting down!");
	}

	public void onMessage(MHMessage message) {
		Thread t = new Thread( new MessageHandler( message));
		t.start();
	}
	
	private class MessageHandler implements Runnable {
		
		private MHMessage message;

		public MessageHandler( MHMessage message) {
			this.message = message;
		}
		
		public void run() {
			int count = bytesToInt( message.getData());
			if (count < 0) {
				forward( message, count);
				stop();
				return;
			}
			count++;
			if (count == target) {
				iWon();
			}
			else {
				forward( message, count);
			}
		}
		
		private void iWon() {
			System.out.println( id + ": we reached " + target + " - i am winner ;)");
			
			// send terminate-message
			message.setSender( id);
			message.setReceiver( (id != 1) ? 1 : 2);
			message.setData( intToBytes( -1));
			try {
				socket.send( message);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (id == 1) stop();
		}
		
		private void forward( MHMessage message, int count) {
			message.setSender( id);
			message.setReceiver( id+1);
			message.setData( intToBytes( count));
			try {
				System.out.println( id + ": forwarding token (" + count + ") to " + (id+1));
				socket.send( message);
			} catch (IOException e) {
//				e.printStackTrace();
				if (count >= 0) {
					System.out.println( id+ ": " + (id+1) + " is unreachabe, trying 1");
					message.setReceiver( 1);
					try {
						socket.send( message);
					} catch (IOException e1) {
						e1.printStackTrace();
						stop();
					}
				}
			}
		}
	}
	
	public static void main(String[] args) {
		int id = Integer.parseInt( args[0]);
		int target = Integer.parseInt( args[1]);
		
		try {
			new MHCounter( id, target);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
